int SensTemp = A0;  // definisce il pin(A0) per il sensore di temperatura 
int PotenzTemp = A1; // definisce il pin(A1) per il potenziometro che sceglie le temperatura
int motore = 13; // definisce il pin per il comando PWM del motore da 1 ms a 2 ms, pin 13
int ValoreSensTemp = 0;  // variabile per memorizzare la temperatura del sensore
int ValorePotenzTemp = 0;  // variabile per memorizzare la posizione del potenziometro
int x = 0;
int xrid = 0;
int y = 0;
double k = 6.1;
/* se la temperatura aumenta, "ValoreSensTemp" aumenta e la durata dell'impulso "alto" in uscita
diminuisce, viceversa la durata dell'impulso "alto" aumenta se la temperatura diminuisce
*/
void setup() {
  // dichiara il pin "motore" come una uscita
  pinMode(motore, OUTPUT);
  
}

   void loop() {
 
  // legge il valore dal sensore di temperatura
  ValoreSensTemp = analogRead(SensTemp);
  // legge il valore della temperatura impostata, "desiderata"
  ValorePotenzTemp = analogRead(PotenzTemp);
  // per il calcolo di k vedi:"Controllo proporzionale di temperatura"
   
      x = 1500 + k * (ValorePotenzTemp - ValoreSensTemp);
      xrid = constrain(x, 1000, 2000); // limita la durata dell'impulso "alto" tra 1000 us e 2000 us
      y = 10000 - x/2; // durata dell'impulso "basso", dimezzata!! 
          
  // impulso alto sul pin "motore"
  digitalWrite(motore, HIGH);  
  // impulso alto per x us
  delayMicroseconds(xrid);          
  // impulso basso sul pin "motore"        
  digitalWrite(motore, LOW);   
  // impulso basso per y us, 2 volte per arrivare a 20 ms ( y max = 16383 )
  delayMicroseconds(y);
  delayMicroseconds(y);
  }

